OGRE-Next: Ogre::SmallVectorImpl< T > Class Template Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
Ogre::SmallVectorImpl< T > Class Template Reference

SmallVectorImpl - This class consists of common code factored out of the SmallVector class to reduce code duplication based on the SmallVector 'N' template parameter. More...

`#include <OgreSmallVector.h>`

Inheritance diagram for Ogre::SmallVectorImpl< T >:
[legend]

## Public Types
typedef SuperClass::iterator | iterator
typedef SuperClass::size_type | size_type
Public Types inherited from Ogre::SmallVectorTemplateCommon< T >
typedef const T * | const_iterator
typedef const T * | const_pointer
typedef const T & | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef ptrdiff_t | difference_type
typedef T * | iterator
typedef T * | pointer
typedef T & | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef size_t | size_type
typedef T | value_type

## Public Member Functions
| SmallVectorImpl (unsigned N)
| ~SmallVectorImpl ()
template<typename in_iter>
void | append (in_iter in_start, in_iter in_end)
| append - Add the specified range to the end of the SmallVector.
void | append (size_type NumInputs, const T &Elt)
| append - Add the specified range to the end of the SmallVector.
void | assign (unsigned NumElts, const T &Elt)
void | clear ()
iterator | erase (iterator I)
iterator | erase (iterator S, iterator E)
iterator | insert (iterator I, const T &Elt)
template<typename ItTy>
iterator | insert (iterator I, ItTy From, ItTy To)
iterator | insert (iterator I, size_type NumToInsert, const T &Elt)
bool | operator!= (const SmallVectorImpl &RHS) const
bool | operator< (const SmallVectorImpl &RHS) const
const SmallVectorImpl & | operator= (const SmallVectorImpl &RHS)
bool | operator== (const SmallVectorImpl &RHS) const
void | pop_back ()
T | pop_back_val ()
void | push_back (const T &Elt)
void | reserve (unsigned N)
void | resize (unsigned N)
void | resize (unsigned N, const T &NV)
void | set_size (unsigned N)
| set_size - Set the array size to
void | swap (SmallVectorImpl &RHS)
Public Member Functions inherited from Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >
| SmallVectorTemplateBase (size_t Size)
| SmallVectorTemplateBase (size_t Size)
void | grow (size_t MinSize=0)
| grow - double the size of the allocated memory, guaranteeing space for at least one more element or MinSize if specified.
void | grow (size_t MinSize=0)
| grow - double the size of the allocated memory, guaranteeing space for at least one more element or MinSize if specified.
Public Member Functions inherited from Ogre::SmallVectorTemplateCommon< T >
| SmallVectorTemplateCommon (size_t Size)
reference | back ()
const_reference | back () const
iterator | begin ()
const_iterator | begin () const
size_t | capacity () const
| capacity - Return the total number of elements in the currently allocated buffer.
pointer | data ()
| data - Return a pointer to the vector's buffer, even if empty().
const_pointer | data () const
| data - Return a pointer to the vector's buffer, even if empty().
iterator | end ()
const_iterator | end () const
reference | front ()
const_reference | front () const
size_type | max_size () const
reference | operator[] (unsigned idx)
const_reference | operator[] (unsigned idx) const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
size_type | size () const
Public Member Functions inherited from Ogre::SmallVectorBase
bool | empty () const

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >
static void | destroy_range (T *S, T *E)
static void | destroy_range (T *S, T *E)
static void | uninitialized_copy (It1 I, It1 E, It2 Dest)
| uninitialized_copy - Copy the range [I, E) onto the uninitialized memory starting with "Dest", constructing elements into it as needed.
static void | uninitialized_copy (It1 I, It1 E, It2 Dest)
| uninitialized_copy - Copy the range [I, E) onto the uninitialized memory starting with "Dest", constructing elements into it as needed.

## Detailed Description

template<typename T>
class Ogre::SmallVectorImpl< T >

SmallVectorImpl - This class consists of common code factored out of the SmallVector class to reduce code duplication based on the SmallVector 'N' template parameter.

## Member Typedef Documentation

## ◆ iterator

template<typename T>

typedef SuperClass::iterator Ogre::SmallVectorImpl< T >::iterator

## ◆ size_type

template<typename T>

typedef SuperClass::size_type Ogre::SmallVectorImpl< T >::size_type

## Constructor & Destructor Documentation

## ◆ SmallVectorImpl()

template<typename T>

Ogre::SmallVectorImpl< T >::SmallVectorImpl | ( | unsigned | N | ) |
| inlineexplicit

## ◆ ~SmallVectorImpl()

template<typename T>

Ogre::SmallVectorImpl< T >::~SmallVectorImpl | ( |  | ) |
| inline

## Member Function Documentation

## ◆ append() [1/2]

template<typename T>
template<typename in_iter>

void Ogre::SmallVectorImpl< T >::append | ( | in_iter | in_start,
|  | in_iter | in_end )
| inline

append - Add the specified range to the end of the SmallVector.

Referenced by Ogre::SmallVector< T, 0 >::SmallVector(), Ogre::U< T >::insert(), Ogre::U< T >::insert(), and Ogre::iterator< T, S >::SmallVector().

## ◆ append() [2/2]

template<typename T>

void Ogre::SmallVectorImpl< T >::append | ( | size_type | NumInputs,
|  | const T & | Elt )
| inline

append - Add the specified range to the end of the SmallVector.

## ◆ assign()

template<typename T>

void Ogre::SmallVectorImpl< T >::assign | ( | unsigned | NumElts,
|  | const T & | Elt )
| inline

## ◆ clear()

template<typename T>

void Ogre::SmallVectorImpl< T >::clear | ( |  | ) |
| inline

Referenced by Ogre::U< T >::assign().

## ◆ erase() [1/2]

template<typename T>

iterator Ogre::SmallVectorImpl< T >::erase | ( | iterator | I | ) |
| inline

## ◆ erase() [2/2]

template<typename T>

iterator Ogre::SmallVectorImpl< T >::erase | ( | iterator | S,
|  | iterator | E )
| inline

## ◆ insert() [1/3]

template<typename T>

iterator Ogre::SmallVectorImpl< T >::insert | ( | iterator | I,
|  | const T & | Elt )
| inline

## ◆ insert() [2/3]

template<typename T>
template<typename ItTy>

iterator Ogre::SmallVectorImpl< T >::insert | ( | iterator | I,
|  | ItTy | From,
|  | ItTy | To )
| inline

## ◆ insert() [3/3]

template<typename T>

iterator Ogre::SmallVectorImpl< T >::insert | ( | iterator | I,
|  | size_type | NumToInsert,
|  | const T & | Elt )
| inline

## ◆ operator!=()

template<typename T>

bool Ogre::SmallVectorImpl< T >::operator!= | ( | const SmallVectorImpl< T > & | RHS | ) | const
| inline

## ◆ operator<()

template<typename T>

bool Ogre::SmallVectorImpl< T >::operator< | ( | const SmallVectorImpl< T > & | RHS | ) | const
| inline

## ◆ operator=()

template<typename T>

const SmallVectorImpl< T > & Ogre::SmallVectorImpl< T >::operator= | ( | const SmallVectorImpl< T > & | RHS | ) |

References Ogre::SmallVectorTemplateCommon< T >::begin(), Ogre::SmallVectorTemplateCommon< T >::capacity(), Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >::destroy_range(), Ogre::SmallVectorTemplateCommon< T >::end(), Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >::grow(), Ogre::SmallVectorTemplateCommon< T >::size(), and Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >::uninitialized_copy().

Referenced by Ogre::SmallVector< T, 0 >::SmallVector(), Ogre::iterator< T, S >::operator=(), and Ogre::SmallVector< T, 0 >::operator=().

## ◆ operator==()

template<typename T>

bool Ogre::SmallVectorImpl< T >::operator== | ( | const SmallVectorImpl< T > & | RHS | ) | const
| inline

## ◆ pop_back()

template<typename T>

void Ogre::SmallVectorImpl< T >::pop_back | ( |  | ) |
| inline

Referenced by Ogre::U< T >::erase(), Ogre::VectorSet< Edge, 8 >::find(), and Ogre::U< T >::pop_back_val().

## ◆ pop_back_val()

template<typename T>

T Ogre::SmallVectorImpl< T >::pop_back_val | ( |  | ) |
| inline

## ◆ push_back()

template<typename T>

void Ogre::SmallVectorImpl< T >::push_back | ( | const T & | Elt | ) |
| inline

Referenced by Ogre::SmallVector< T, 0 >::SmallVector(), Ogre::VectorSet< T, S >::add(), Ogre::VectorSet< T, S >::addNotExists(), Ogre::U< T >::insert(), and Ogre::iterator< T, S >::SmallVector().

## ◆ reserve()

template<typename T>

void Ogre::SmallVectorImpl< T >::reserve | ( | unsigned | N | ) |
| inline

Referenced by Ogre::SmallVector< T, 0 >::SmallVector(), Ogre::U< T >::insert(), Ogre::U< T >::insert(), and Ogre::iterator< T, S >::SmallVector().

## ◆ resize() [1/2]

template<typename T>

void Ogre::SmallVectorImpl< T >::resize | ( | unsigned | N | ) |
| inline

## ◆ resize() [2/2]

template<typename T>

void Ogre::SmallVectorImpl< T >::resize | ( | unsigned | N,
|  | const T & | NV )
| inline

## ◆ set_size()

template<typename T>

void Ogre::SmallVectorImpl< T >::set_size | ( | unsigned | N | ) |
| inline

set_size - Set the array size to

- N, which the current array must have enough capacity for.

This does not construct or destroy any elements in the vector.

Clients can use this in conjunction with capacity() to write past the end of the buffer when they know that more elements are available, and only update the size later. This avoids the cost of value initializing elements which will only be overwritten.

## ◆ swap()

template<typename T>

void Ogre::SmallVectorImpl< T >::swap | ( | SmallVectorImpl< T > & | RHS | ) |

References Ogre::SmallVectorTemplateCommon< T >::begin(), Ogre::SmallVectorTemplateCommon< T >::capacity(), Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >::destroy_range(), Ogre::SmallVectorTemplateCommon< T >::end(), Ogre::SmallVectorTemplateBase< T, isPodLike >::grow(), Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >::grow(), Ogre::SmallVectorTemplateCommon< T >::size(), std::swap(), and Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >::uninitialized_copy().

Referenced by std::swap(), and std::swap().

The documentation for this class was generated from the following file:

- OgreSmallVector.h